Loading...
Searching...
No Matches
itk::ImageFullSampler< TInputImage > Class Template Reference
Components » ImageSamplers

`#include <itkImageFullSampler.h>`

## Detailed Description

template<class TInputImage>
class itk::ImageFullSampler< TInputImage >

Samples all voxels in the InputImageRegion.

This ImageSampler samples all voxels in the InputImageRegion. If a mask is given: only those voxels within the mask AND the InputImageRegion.

Definition at line 38 of file itkImageFullSampler.h.

Inheritance diagram for itk::ImageFullSampler< TInputImage >:
[legend]

## Data Structures

struct | UserData
struct | WorkUnit

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | ImageSampleContainerPointer
using | ImageSampleContainerType
using | ImageSampleType
using | InputImageConstPointer
using | InputImageIndexType
using | InputImagePixelType
using | InputImagePointer
using | InputImagePointType
using | InputImageRegionType
using | InputImageSizeType = typename InputImageType::SizeType
using | InputImageType
using | MaskType = typename Superclass::MaskType
using | Pointer = SmartPointer<Self>
using | Self = ImageFullSampler
using | Superclass = ImageSamplerBase<TInputImage>
Public Types inherited from itk::ImageSamplerBase< TInputImage >
using | ConstPointer = SmartPointer<const Self>
using | ImageSampleContainerPointer = typename ImageSampleContainerType::Pointer
using | ImageSampleContainerType = VectorDataContainer<std::vcl_size_t, ImageSampleType>
using | ImageSampleType = ImageSample<InputImageType>
using | ImageSampleValueType = typename ImageSampleType::RealType
using | InputImageConstPointer = typename InputImageType::ConstPointer
using | InputImageIndexType = typename InputImageType::IndexType
using | InputImagePixelType = typename InputImageType::PixelType
using | InputImagePointer = typename InputImageType::Pointer
using | InputImagePointType = typename InputImageType::PointType
using | InputImagePointValueType = typename InputImagePointType::ValueType
using | InputImageRegionType = typename InputImageType::RegionType
using | InputImageRegionVectorType = std::vector<InputImageRegionType>
using | InputImageSizeType = typename InputImageType::SizeType
using | InputImageType = TInputImage
using | MaskConstPointer = typename MaskType::ConstPointer
using | MaskPointer = typename MaskType::Pointer
using | MaskType = ImageMaskSpatialObject<Self::InputImageDimension>
using | MaskVectorType = std::vector<MaskConstPointer>
using | OutputVectorContainerPointer
using | OutputVectorContainerType
using | Pointer = SmartPointer<Self>
using | Self = ImageSamplerBase
using | Superclass = VectorContainerSource<VectorDataContainer<std::vcl_size_t, ImageSample<TInputImage>>>
Public Types inherited from itk::VectorContainerSource< VectorDataContainer< std::vcl_size_t, ImageSample< TInputImage > > >
using | ConstPointer
using | OutputVectorContainerPointer
using | OutputVectorContainerType
using | Pointer
using | Self
using | Superclass

## Public Member Functions

virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (ImageFullSampler)
| itkStaticConstMacro (InputImageDimension, unsigned int, Superclass::InputImageDimension)
bool | SelectingNewSamplesOnUpdateSupported () const override
bool | SelectNewSamplesOnUpdate () override
Public Member Functions inherited from itk::ImageSamplerBase< TInputImage >
virtual const InputImageRegionType & | GetCroppedInputImageRegion ()
const InputImageType * | GetInput ()
const InputImageType * | GetInput (unsigned int idx)
virtual const InputImageRegionType & | GetInputImageRegion () const
virtual const InputImageRegionType & | GetInputImageRegion (unsigned int pos) const
virtual const MaskType * | GetMask () const
virtual const MaskType * | GetMask (unsigned int pos) const
virtual unsigned int | GetNumberOfInputImageRegions () const
virtual unsigned int | GetNumberOfMasks () const
virtual unsigned long | GetNumberOfSamples () const
OutputVectorContainerType * | GetOutput ()
| ITK_DISALLOW_COPY_AND_MOVE (ImageSamplerBase)
| itkStaticConstMacro (InputImageDimension, unsigned int, InputImageType::ImageDimension)
DataObject::Pointer | MakeOutput (ProcessObject::DataObjectPointerArraySizeType idx) override
void | SetInput (const InputImageType *input)
void | SetInput (unsigned int idx, const InputImageType *input)
virtual void | SetInputImageRegion (const InputImageRegionType _arg)
virtual void | SetInputImageRegion (const InputImageRegionType _arg, unsigned int pos)
virtual void | SetMask (const MaskType *_arg)
virtual void | SetMask (const MaskType *_arg, unsigned int pos)
virtual void | SetNumberOfInputImageRegions (const unsigned int _arg)
virtual void | SetNumberOfMasks (const unsigned int _arg)
virtual void | SetNumberOfSamples (unsigned long _arg)
virtual void | SetUseMultiThread (bool _arg)
Public Member Functions inherited from itk::VectorContainerSource< VectorDataContainer< std::vcl_size_t, ImageSample< TInputImage > > >
OutputVectorContainerType * | GetOutput ()
OutputVectorContainerType * | GetOutput (unsigned int idx)
virtual void | GraftNthOutput (unsigned int idx, DataObject *output)
virtual void | GraftOutput (DataObject *output)
| ITK_DISALLOW_COPY_AND_MOVE (VectorContainerSource)
DataObjectPointer | MakeOutput (ProcessObject::DataObjectPointerArraySizeType idx) override

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::ImageSamplerBase< TInputImage >
static Pointer | New ()
Static Public Member Functions inherited from itk::VectorContainerSource< VectorDataContainer< std::vcl_size_t, ImageSample< TInputImage > > >
static Pointer | New ()

## Protected Member Functions

void | GenerateData () override
| ImageFullSampler ()=default
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~ImageFullSampler () override=default
Protected Member Functions inherited from itk::ImageSamplerBase< TInputImage >
virtual bool | CheckInputImageRegions ()
void | CropInputImageRegion ()
void | GenerateInputRequestedRegion () override
| ImageSamplerBase ()
virtual bool | IsInsideAllMasks (const InputImagePointType &point) const
void | PrintSelf (std::ostream &os, Indent indent) const override
virtual void | UpdateAllMasks ()
| ~ImageSamplerBase () override=default
Protected Member Functions inherited from itk::VectorContainerSource< VectorDataContainer< std::vcl_size_t, ImageSample< TInputImage > > >
void | PrintSelf (std::ostream &os, Indent indent) const override
| VectorContainerSource ()
| ~VectorContainerSource () override=default

## Static Private Member Functions

template<elastix::MaskCondition VMaskCondition>
static void | GenerateDataForWorkUnit (WorkUnit &, const InputImageType &, const MaskType *)
static std::vector< WorkUnit > | GenerateWorkUnits (const ThreadIdType numberOfWorkUnits, const InputImageRegionType &croppedInputImageRegion, std::vector< ImageSampleType > &samples)
static void | MultiThreadedGenerateData (MultiThreaderBase &multiThreader, const ThreadIdType numberOfWorkUnits, const TInputImage &inputImage, const MaskType *const mask, const InputImageRegionType &croppedInputImageRegion, std::vector< ImageSampleType > &samples)
static void | SingleThreadedGenerateData (const TInputImage &inputImage, const MaskType *const mask, const InputImageRegionType &croppedInputImageRegion, std::vector< ImageSampleType > &samples)
template<elastix::MaskCondition VMaskCondition>
static ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION | ThreaderCallback (void *arg)

## Additional Inherited Members

Static Protected Member Functions inherited from itk::ImageSamplerBase< TInputImage >
static std::vector< InputImageRegionType > | SplitRegion (const InputImageRegionType &inputRegion, const vcl_size_t requestedNumberOfSubregions)
Protected Attributes inherited from itk::ImageSamplerBase< TInputImage >
unsigned long | m_NumberOfSamples { 0 }
bool | m_UseMultiThread { true }

## Member Typedef Documentation

## ConstPointer

template<class TInputImage>

using itk::ImageFullSampler< TInputImage >::ConstPointer = SmartPointer<const Self>

Definition at line 47 of file itkImageFullSampler.h.

## ImageSampleContainerPointer

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::ImageSampleContainerPointer

Definition at line 78 of file itkImageSamplerBase.h.

## ImageSampleContainerType

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::ImageSampleContainerType

Definition at line 77 of file itkImageSamplerBase.h.

## ImageSampleType

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::ImageSampleType

Other typdefs.

Definition at line 76 of file itkImageSamplerBase.h.

## InputImageConstPointer

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::InputImageConstPointer

Definition at line 68 of file itkImageSamplerBase.h.

## InputImageIndexType

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::InputImageIndexType

Definition at line 80 of file itkImageSamplerBase.h.

## InputImagePixelType

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::InputImagePixelType

Definition at line 70 of file itkImageSamplerBase.h.

## InputImagePointer

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::InputImagePointer

Definition at line 67 of file itkImageSamplerBase.h.

## InputImagePointType

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::InputImagePointType

Definition at line 81 of file itkImageSamplerBase.h.

## InputImageRegionType

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::InputImageRegionType

Definition at line 69 of file itkImageSamplerBase.h.

## InputImageSizeType

template<class TInputImage>

using itk::ImageFullSampler< TInputImage >::InputImageSizeType = typename InputImageType::SizeType

Typedefs for support of user defined grid spacing for the spatial samples.

Definition at line 81 of file itkImageFullSampler.h.

## InputImageType

template<class TInputImage>

using itk::ImageSamplerBase< TInputImage >::InputImageType

Some Image related typedefs.

Definition at line 66 of file itkImageSamplerBase.h.

## MaskType

template<class TInputImage>

using itk::ImageFullSampler< TInputImage >::MaskType = typename Superclass::MaskType

Definition at line 70 of file itkImageFullSampler.h.

## Pointer

template<class TInputImage>

using itk::ImageFullSampler< TInputImage >::Pointer = SmartPointer<Self>

Definition at line 46 of file itkImageFullSampler.h.

## Self

template<class TInputImage>

using itk::ImageFullSampler< TInputImage >::Self = ImageFullSampler

Standard ITK-stuff.

Definition at line 44 of file itkImageFullSampler.h.

## Superclass

template<class TInputImage>

using itk::ImageFullSampler< TInputImage >::Superclass = ImageSamplerBase<TInputImage>

Definition at line 45 of file itkImageFullSampler.h.

## Constructor & Destructor Documentation

## ImageFullSampler()

template<class TInputImage>

itk::ImageFullSampler< TInputImage >::ImageFullSampler | ( |  | ) |

protected default

The constructor.

## ~ImageFullSampler()

template<class TInputImage>

itk::ImageFullSampler< TInputImage >::~ImageFullSampler | ( |  | ) |

override protected default

The destructor.

## Member Function Documentation

## GenerateData()

template<class TInputImage>

void itk::ImageFullSampler< TInputImage >::GenerateData | ( |  | ) |

override protected

Function that does the work.

## GenerateDataForWorkUnit()

template<class TInputImage>
template<elastix::MaskCondition VMaskCondition>

void itk::ImageFullSampler< TInputImage >::GenerateDataForWorkUnit | ( | WorkUnit & | ,
|  | const InputImageType & | ,
|  | const MaskType * | )

static private

Generates the data for one specific work unit.

## GenerateWorkUnits()

template<class TInputImage>

std::vector< WorkUnit > itk::ImageFullSampler< TInputImage >::GenerateWorkUnits | ( | const ThreadIdType | numberOfWorkUnits,
|  | const InputImageRegionType & | croppedInputImageRegion,
|  | std::vector< ImageSampleType > & | samples )

static private

Generates the work units, to be processed when doing multi-threading.

## GetClassName()

template<class TInputImage>

virtual const char * itk::ImageFullSampler< TInputImage >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::ImageSamplerBase< TInputImage >.

Reimplemented in elastix::FullSampler< TElastix >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TInputImage>

itk::ImageFullSampler< TInputImage >::ITK_DISALLOW_COPY_AND_MOVE | ( | ImageFullSampler< TInputImage > |  | ) |

## itkStaticConstMacro()

template<class TInputImage>

itk::ImageFullSampler< TInputImage >::itkStaticConstMacro | ( | InputImageDimension | ,
|  | unsigned int | ,
|  | Superclass::InputImageDimension | )

The input image dimension.

## MultiThreadedGenerateData()

template<class TInputImage>

void itk::ImageFullSampler< TInputImage >::MultiThreadedGenerateData | ( | MultiThreaderBase & | multiThreader,
|  | const ThreadIdType | numberOfWorkUnits,
|  | const TInputImage & | inputImage,
|  | const MaskType *const | mask,
|  | const InputImageRegionType & | croppedInputImageRegion,
|  | std::vector< ImageSampleType > & | samples )

static private

## New()

template<class TInputImage>

Pointer itk::ImageFullSampler< TInputImage >::New | ( |  | ) |

static

Method for creation through the object factory.

## PrintSelf()

template<class TInputImage>

void itk::ImageSamplerBase< TInputImage >::PrintSelf | ( | std::ostream & | os,
|  | Indent | indent ) const

override protected

PrintSelf.

## SelectingNewSamplesOnUpdateSupported()

template<class TInputImage>

bool itk::ImageFullSampler< TInputImage >::SelectingNewSamplesOnUpdateSupported | ( |  | ) | const

inline override virtual

Returns whether the sampler supports SelectNewSamplesOnUpdate().

Reimplemented from itk::ImageSamplerBase< TInputImage >.

Definition at line 93 of file itkImageFullSampler.h.

## SelectNewSamplesOnUpdate()

template<class TInputImage>

bool itk::ImageFullSampler< TInputImage >::SelectNewSamplesOnUpdate | ( |  | ) |

inline override virtual

Selecting new samples makes no sense if nothing changed. The same samples would be selected anyway.

Reimplemented from itk::ImageSamplerBase< TInputImage >.

Definition at line 85 of file itkImageFullSampler.h.

## SingleThreadedGenerateData()

template<class TInputImage>

void itk::ImageFullSampler< TInputImage >::SingleThreadedGenerateData | ( | const TInputImage & | inputImage,
|  | const MaskType *const | mask,
|  | const InputImageRegionType & | croppedInputImageRegion,
|  | std::vector< ImageSampleType > & | samples )

static private

## ThreaderCallback()

template<class TInputImage>
template<elastix::MaskCondition VMaskCondition>

ITK_THREAD_RETURN_FUNCTION_CALL_CONVENTION itk::ImageFullSampler< TInputImage >::ThreaderCallback | ( | void * | arg | ) |

static private

Generated on 1768596610 for elastix by 1.15.0 |